tool

extends Node2D

#Body Sprite
var _body = null
#End Sprite
var _end = null
var _body_width
export(float,0.0,1.0,0.01) var region_rect_x = 0.0 setget _set_region_rect_x
export(float,0.0,5000.0,0.1) var beam_size_x = 256 setget _set_beam_size_x

func _ready():
	_body = get_node("body_sprite")
	_end = get_node("end_animated_sprite")
	_body_width = _body.get_texture().get_width()

func _notification(what):
	if(what == NOTIFICATION_TRANSFORM_CHANGED):
		_update_end_position()

func _set_region_rect_x(value):
	region_rect_x = value
	_update_body_region_rect_x()

func _set_beam_size_x(value):
	beam_size_x = value
	_update_body_width()
	_update_end_position()

func _update_body_region_rect_x():
	if(_body != null):
		var rect = _body.get_region_rect()
		rect.pos.x = -region_rect_x * _body_width
		_body.set_region_rect(rect)

func _update_body_width():
	if(_body != null):
		var rect = _body.get_region_rect()
		rect.size.width = beam_size_x
		_body.set_region_rect(rect)

func _update_end_position():
	if(_body != null && _end != null):
		var pos = _body.get_pos()
		pos.x += beam_size_x
		pos.rotated(self.get_rot())
		_end.set_pos(pos)



